(* Written by:
   Barry Comer
   2 Cleveland Crescent
   Dartmouth, Nova Scotia
   Canada
   B3A-2L6
   1-(902)-466-5345 
  
Also I am looking for some source code for the GST Assembler,if you have 
some showing how it works with the VDI, please let me hear from you. *)

MODULE NeoDemo;(*Import calls from liabrary.*)

FROM VDIControls  IMPORT OpenVirtualWorkstation,CloseVirtualWorkstation,
                         ClearWorkstation;
FROM VDIInputs    IMPORT HideCursor,ShowCursor,SampleMouseButton;
FROM VDIAttribs   IMPORT SetWritingMode;
FROM GEMVDIbase   IMPORT VDIWorkInType,VDIWorkOutType,BigPxyArrayType;
FROM VDIRasters   IMPORT CopyRasterOpaque,MFDBType;
FROM AESGraphics  IMPORT GrafHandle;
FROM XBIOS        IMPORT SetScreenBase,SetPalette,ScreenPhysicalBase,Palette                         ,SetColour,GetResolution,VSync;
FROM SYSTEM       IMPORT ADDRESS,ADR;
FROM GEMDOS       IMPORT Open,Close,Read;

(*Set up variables for liabrary calls.*)

VAR  handle,filehandle,delay0,delay1,i,rez,
     dummy,button,col,row                      :INTEGER;
     In                                        :VDIWorkInType;
     Out                                       :VDIWorkOutType;
     filename                                  :ARRAY [0..255] OF CHAR;
     junkbuff                                  :ARRAY [0..50] OF INTEGER;
     newpal,savepal                            :Palette;
     recordsize,filesize                       :LONGCARD;
     screen,scrdif                             :ADDRESS;
     done                                      :BOOLEAN;
     SMFDB,BMFDB0,BMFDB1                       :MFDBType;
     PxyArray0,PxyArray1                       :BigPxyArrayType;

(*====================================================================*)

PROCEDURE Init;(*Open work station.*)
VAR i,dummy:INTEGER;
BEGIN
 handle:=GrafHandle(dummy,dummy,dummy,dummy);
 FOR i:=0 TO 9 DO In[i]:=1 END;
 In[10]:=2;
 OpenVirtualWorkstation(In,handle,Out);
 HideCursor(handle);
 ClearWorkstation(handle);
 dummy:=SetWritingMode(handle,3);
END Init;

(*======================================================================*)

PROCEDURE Endit;
BEGIN
ShowCursor(handle,0);
 CloseVirtualWorkstation(handle);
END Endit;

(*======================================================================*)

PROCEDURE SavePal;(*Store the presant colors into an array for later.*)
BEGIN
FOR i:=0 TO 15 DO;
 savepal[i]:=SetColour(i,-1);
END;
END SavePal;

(*======================================================================*)

PROCEDURE RestorePal;(*Place saved colour values back into their place.*)
BEGIN
 SetPalette(savepal);
END RestorePal;

(*=====================================================================*)

PROCEDURE SaveRez;(*Save presant screen resolution.*)
BEGIN
 rez:=GetResolution();
END SaveRez;

(*======================================================================*)

PROCEDURE RestoreRez;(*Restore screen resolution.*)
BEGIN
 SetScreenBase(ADDRESS(-1),ADDRESS(-1),rez);
END RestoreRez;

(*====================================================================*)

PROCEDURE FindScreen;(*Store location of screen.*)
BEGIN
 screen:=ScreenPhysicalBase();
END FindScreen;

(*=======================================================================*)

PROCEDURE ReadScreen;(*Read Neochrome pics. into memory.*)
BEGIN
(*Load picture under the screen memory.*)
        filename:="SPACEWAR.PI2";
        Open(filename,0,filehandle);
        recordsize:=2;
        Read(filehandle,recordsize,ADR(junkbuff));
        SetScreenBase(ADDRESS(-1),ADDRESS(-1),junkbuff[0]);
        recordsize:=32;
        Read(filehandle,recordsize,ADR(newpal));
        SetPalette(newpal);
        recordsize:=32000;
        Read(filehandle,recordsize,screen-32768);
        done:=Close(filehandle);
END ReadScreen;

(*===================================================================*)

PROCEDURE ScreenMFDB; (* Memory Form Def. Block for screen. *)
BEGIN           
 SMFDB.pointer:=screen;
 SMFDB.width:=640;
 SMFDB.height:=200;
 SMFDB.widthW:=40;
 SMFDB.format:=1;
 SMFDB.planes:=2;
 SMFDB.rsrvd1:=0;
 SMFDB.rsrvd2:=0;
END ScreenMFDB;

(*=====================================================================*)

PROCEDURE BufferMFDB0; (* Memory Form Def. Block for Enterprize. *)
BEGIN           
 BMFDB0.pointer:=(screen-32768);
 BMFDB0.width:=640;
 BMFDB0.height:=200;
 BMFDB0.widthW:=40;
 BMFDB0.format:=1;
 BMFDB0.planes:=2;
 BMFDB0.rsrvd1:=0;
 BMFDB0.rsrvd2:=0;
END BufferMFDB0;

(*======================================================================*)  
PROCEDURE BufferMFDB1; (* Memory Form Def. Block for Klingon. *)
BEGIN           
 BMFDB1.pointer:=(screen-32768);
 BMFDB1.width:=640;
 BMFDB1.height:=200;
 BMFDB1.widthW:=40;
 BMFDB1.format:=1;
 BMFDB1.planes:=2;
 BMFDB1.rsrvd1:=0;
 BMFDB1.rsrvd2:=0;
END BufferMFDB1;

(*=====================================================================*)

PROCEDURE FromTo0; (*Define raster copy variables for Enterprize.*)
BEGIN
 PxyArray0[0]:=0;
 PxyArray0[1]:=0;
 PxyArray0[2]:=0;
 PxyArray0[3]:=0;
 PxyArray0[4]:=320;(*X,Y screen locations in med. rez.*)
 PxyArray0[5]:=50;
 PxyArray0[6]:=352;
 PxyArray0[7]:=65;
END FromTo0;

(*=======================================================================*)

PROCEDURE FromTo1; (*Define raster copy variables for Klingon.*)
BEGIN
 PxyArray1[0]:=0;
 PxyArray1[1]:=0;
 PxyArray1[2]:=0;
 PxyArray1[3]:=0;
 PxyArray1[4]:=320;(*X,Y screen locations in med. rez.*)
 PxyArray1[5]:=70;
 PxyArray1[6]:=352;
 PxyArray1[7]:=85;
END FromTo1;
(*======================================================================*) 

PROCEDURE Copy0;(* Actual call that copies Enterprize.*)
BEGIN;
VSync;
 CopyRasterOpaque(handle,6,PxyArray0,ADR(BMFDB0),ADR(SMFDB));
FOR i:=0 TO 1400 DO END; (* Delay to let the screen catch up. *)
 CopyRasterOpaque(handle,6,PxyArray0,ADR(BMFDB0),ADR(SMFDB));
END Copy0;

(*=====================================================================*)

PROCEDURE Copy1;(* Actual call that copies Klingons.*)
BEGIN;
VSync;
 CopyRasterOpaque(handle,6,PxyArray1,ADR(BMFDB1),ADR(SMFDB));
FOR i:=0 TO 1400 DO END; (* Delay to let the screen catch up. *)
 CopyRasterOpaque(handle,6,PxyArray1,ADR(BMFDB1),ADR(SMFDB));
END Copy1;

(*======================================================================*) 

PROCEDURE MoveImg; (*Pass values to copy raster call and delay.*)
BEGIN
FOR row:=0 TO  15 BY 15 DO;(* Row of Degas pic. to copy. *)
FOR col:=0 TO 480 BY 32 DO;(* Col. of gegas pic. to copy. *)
 PxyArray0[0]:=col;
 PxyArray0[1]:=row;
 PxyArray0[2]:=col+32;
 PxyArray0[3]:=row+15;
Copy0;
 PxyArray1[0]:=col;
 PxyArray1[1]:=row+32;
 PxyArray1[2]:=col+32;
 PxyArray1[3]:=row+47;
Copy1;
END;
END;
END MoveImg;

(*=====================================================================*)
BEGIN
 Init;(*Open work starion.*)
 SavePal;(*Save colours.*)
 SaveRez;(*Save screen resolution.*)
 FindScreen;(*Find screen's location in memory.*)
 ReadScreen;(*Read NEO. pic into buffer.*)
 ScreenMFDB;(*Init. screen MFDB.*)
 BufferMFDB0;(*Init. Enterprize MFDB.*)
 BufferMFDB1; (*Init. Klingon MFDB. *)
 FromTo0;(*Init PxyArray for Copy Raster calls. *)
 FromTo1;
REPEAT;
 SampleMouseButton(handle,button,dummy,dummy);
 MoveImg;(*Call on procedures to move imiges.*)
UNTIL button=3; (* Press both buttons to end. *)
 RestorePal;(*Restore colours.*)
  RestoreRez;(*Restore screen rez.*)
 Endit;(*Close work station.*)
END NeoDemo.